<?php
/**
 * 升级程序用于5.3.1 to 6.0.0，更新数据库
 * By StarYu
 * http://www.myxzy.com
 */
require_once('init.php');
?>

<!DOCTYPE HTML>
<html lang="zh-CN">
  <head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=Edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>emlog数据库升级程序 - 星知苑</title>
<style type="text/css">
<!--
body {
	background-color:#F7F7F7;
	font-family: Arial;
	font-size: 12px;
	line-height:250%;
}
.main {
	background-color:#FFFFFF;
	color: #666666;
	width:730px;
	margin:10px auto;
	padding:10px;
	list-style:none;
	border:#DFDFDF 1px solid;
}
#ver{
	font-size:18px;
	text-align:center;
}
.title{
	font-size:24px;
	font-weight:bold;
}
.iteam{
	font-size:18px;
	font-weight:bold;
	color:#666666;
	border-bottom: #CCCCCC 1px solid;
	padding:10px;
}
li{
	list-style:none;
}
.foot{
	text-align:center;
}
-->
</style>
</head>
<body>
<div class="main">
<p id="ver">emlog升级程序</p>
<?php
if(!isset($_GET['action'])){
?>
<div>
<p class="iteam">特别提示，声明</p>
<ul>
<li style="color:#FF0000;">1、升级之前务必对老的数据库以及全部的文件进行备份！</li>
<li>2、我们愿意帮你解决升级过程中遇到的问题，但不承担由此造成的数据丢失等责任，特此声明！</li>
<li>3、请认真阅读注意事项后再开始按照升级步骤升级你的博客</li>
<li>4、模板插件兼容性没有做测试</li>
</ul>

<p class="iteam">升级步骤</p>
<ul style="font-size:14px;">
<li><span style="color: #FF0000;"><b>第1步</b></span>：将update.php文件上传到网站根目录（Config.php同目录）</li>
<li><span style="color: #0066FF;"><b>第2步</b></span>：浏览器运行该网页，按照提示操作</li>
<li><span style="color: #993333;"><b>第3步</b></span>：官网下载emlog6.0.0版本，除install.php和config.php其他的全部上传替换</li>
<li><span style="color: #003333;"><b>第4步</b></span>：进入后台更新缓存,删除update.php升级文件</li>
</ul>
<form name="form1" method="post" action="update.php?action=install">
<p class="iteam">升级操作</p>
<ul style="font-size:14px;">
<li><span style="color: #000000;"><b>当前emlog版本</b></span>：<?php echo Option::EMLOG_VERSION;if(Option::EMLOG_VERSION == '5.3.1') {echo '<strong style="color:green"> 满足升级条件</strong>';}else{echo '<strong style="color:red"> 不满足升级条件</strong>';}?></li>
<li><span style="color: #000000;"><b>数据库密码</b></span>：<input name="password" type="password" class="input" value="">(服务器上config.php文件里 DB_PASSWD 对应值)</li>
<li>
<input type="submit" class="submit" value="确 定">
<input type="reset" class="submit" value="重 置">
</li>
</ul>
</form>
</div>
<?php }?>
<ul style="font-size:14px;">
<?php if (isset($_GET['action'])&&$_GET['action'] == "install") {
	$DB = Database::getInstance();
    $db_prefix = DB_PREFIX;

	if (DB_PASSWD != trim($_POST['password'])){
	    exit("输入的数据库密码错误,请重新输入");
	}

$sql = "
ALTER TABLE {$db_prefix}blog ADD tags text;
ALTER TABLE {$db_prefix}blog drop index date;
ALTER TABLE {$db_prefix}blog drop index hide;
ALTER TABLE {$db_prefix}blog drop index type;
ALTER TABLE {$db_prefix}blog add  index top(top,date);
INSERT INTO {$db_prefix}options (option_name, option_value) VALUES ('detect_url','n');
DROP TABLE IF EXISTS {$db_prefix}storage;
CREATE TABLE {$db_prefix}storage (
  `sid` int(8) NOT NULL AUTO_INCREMENT,
  `plugin` varchar(32) NOT NULL,
  `name` varchar(32) NOT NULL,
  `type` varchar(8) NOT NULL,
  `value` text NOT NULL,
  `createdate` int(11) NOT NULL,
  `lastupdate` int(11) NOT NULL,
  PRIMARY KEY (`sid`),
  UNIQUE KEY `plugin` (`plugin`,`name`)
)";

$array_sql = preg_split("/;[\r\n]/", $sql);
foreach($array_sql as $sql)
{
	$sql = trim($sql);
	if ($sql) {
		$DB->query($sql);
	}
}

$blog_sql = "SELECT * FROM `{$db_prefix}blog`";
$rows = $DB->query($blog_sql);
while ($row = $DB->fetch_array($rows)) {
	$i = $row['gid'];
	$tag_sql = "SELECT * FROM `{$db_prefix}tag` WHERE gid LIKE '%,$i,%'";
	$obj = $DB->query($tag_sql);
	$arr = array();
	while($row = $DB->fetch_array($obj)){
		$arr[] = $row['tid'];
	}
	$tags = implode(",", $arr);
	$tags_sql = "UPDATE {$db_prefix}blog SET tags='$tags' WHERE gid='$i'";
	$DB->query($tags_sql);
}

$tag_fix = "SELECT tid,gid FROM `{$db_prefix}tag`";
$res = $DB->query($tag_fix);
while ($row = $DB->fetch_array($res)) {
	$gid = trim($row['gid'],',');
	$tid = $row['tid'];
	$res_sql = "UPDATE {$db_prefix}tag SET gid='$gid' WHERE tid='$tid'";
	$DB->query($res_sql);
}

echo("恭喜你！emlog已成功升级到6.0.0 <a href=\"./\"> 进入博客&raquo; </a>");
}
?>
</ul>
<ul style="font-size:14px;">
<li>由<a href = "http://www.myxzy.com/post-474.html">星知苑</a>提供技术支持</li>
</ul>
</div>
</body>
</html>